/*
 * 
 * Copyright (C) 2007:  Fabio Campisi (campisi@cli.di.unipi.it) 
 *                      Daniele Sgandurra (daniele@di.unipi.it)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * --------------------
 *
 * Author(s): Fabio Campisi (campisi@cli.di.unipi.it) 
 *            Daniele Sgandurra (daniele@di.unipi.it)
 *
 */


#include <openssl/evp.h>
#include <openssl/crypto.h>
#include "xen_vmi.h"

/*msg=array di puntatori, es. a pagine
  len=lunghezza singola pagina
  max=numero pagine*/
void calculate_hash(unsigned char **msg, size_t len, int max, unsigned char **md_value, unsigned int *md_len)
{
     EVP_MD_CTX mdctx;
     const EVP_MD *md = EVP_sha1();
     int i;
  
     *md_value = (unsigned char*)malloc(sizeof(unsigned char) * EVP_MAX_MD_SIZE);
 
     OpenSSL_add_all_digests();

     if(!md)
     {
	  printf("Unknown message digest \n");
	  exit(1);
     }

     EVP_MD_CTX_init(&mdctx);
     EVP_DigestInit_ex(&mdctx, md, NULL);
     for(i=0; i<max; i++) {
	  /*int EVP_DigestUpdate(EVP_MD_CTX *ctx, const void *d, size_t cnt);*/
	  EVP_DigestUpdate(&mdctx, msg[i], len);
     }

     EVP_DigestFinal_ex(&mdctx, *md_value, md_len);
     EVP_MD_CTX_cleanup(&mdctx);
}


