/*
 * 
 * Copyright (C) 2007:  Fabio Campisi (campisi@cli.di.unipi.it) 
 *                      Daniele Sgandurra (daniele@di.unipi.it)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * --------------------
 *
 * Author(s): Fabio Campisi (campisi@cli.di.unipi.it) 
 *            Daniele Sgandurra (daniele@di.unipi.it)
 *
 */


#ifndef XEN_VMI_HEADER
#define XEN_VMI_HEADER

#define MODULE_NAME_LEN (64 - sizeof(unsigned long))
#define DIGEST_SIZE 20
#define XC_PAGE_SHIFT 12
#define IDT_ENTRIES 256
#define XC_PAGE_SIZE            (1UL << XC_PAGE_SHIFT)
#define XA_PAGE_SIZE XC_PAGE_SIZE


typedef unsigned int uint32_t;
typedef unsigned char uint8_t;
typedef unsigned short int uint16_t;

struct digest_info
{
     char name[MODULE_NAME_LEN];
     unsigned char digest[DIGEST_SIZE];
};

typedef struct trap_info
{
     uint8_t       vector;  /* exception vector                              */
     uint8_t       flags;   /* 0-3: privilege level; 4: clear event enable?  */
     uint16_t      cs;      /* code selector                                 */
     unsigned long address; /* code offset                                   */
} trap_info_t;

void calculate_hash(unsigned char **msg, size_t len, int max, unsigned char **md_value, unsigned int *md_len);
int get_sys_call_table(uint32_t **sys_table, int *max, uint32_t dom);
int get_kernel_text(unsigned char ***text_page, int *page_num, uint32_t dom);
int get_idt_table(unsigned char ***idt_table, uint32_t dom);
int get_module_list(uint32_t dom);
int get_process_list(uint32_t dom);
int print_promisc_if(uint32_t dom);
int print_process_infos(uint32_t dom);
int list_open_files(uint32_t dom);

#endif
